/* Generated by wayland-scanner 1.23.0 */

#ifndef TEST_DRIVER_CLIENT_PROTOCOL_H
#define TEST_DRIVER_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_test_driver The test_driver protocol
 * @section page_ifaces_test_driver Interfaces
 * - @subpage page_iface_test_driver - 
 */
struct test_driver;
struct wl_callback;
struct wl_surface;

#ifndef TEST_DRIVER_INTERFACE
#define TEST_DRIVER_INTERFACE
/**
 * @page page_iface_test_driver test_driver
 * @section page_iface_test_driver_api API
 * See @ref iface_test_driver.
 */
/**
 * @defgroup iface_test_driver The test_driver interface
 */
extern const struct wl_interface test_driver_interface;
#endif

#ifndef TEST_DRIVER_DIRECTION_ENUM
#define TEST_DRIVER_DIRECTION_ENUM
enum test_driver_direction {
	TEST_DRIVER_DIRECTION_LEFT = 1,
	TEST_DRIVER_DIRECTION_RIGHT = 2,
};
#endif /* TEST_DRIVER_DIRECTION_ENUM */

/**
 * @ingroup iface_test_driver
 * @struct test_driver_listener
 */
struct test_driver_listener {
	/**
	 */
	void (*sync_event)(void *data,
			   struct test_driver *test_driver,
			   uint32_t sequence);
	/**
	 */
	void (*property)(void *data,
			 struct test_driver *test_driver,
			 const char *name,
			 const char *value);
};

/**
 * @ingroup iface_test_driver
 */
static inline int
test_driver_add_listener(struct test_driver *test_driver,
			 const struct test_driver_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) test_driver,
				     (void (**)(void)) listener, data);
}

#define TEST_DRIVER_SYNC_ACTOR_DESTROYED 0
#define TEST_DRIVER_SYNC_EFFECTS_COMPLETED 1
#define TEST_DRIVER_SYNC_WINDOW_SHOWN 2
#define TEST_DRIVER_SYNC_POINT 3
#define TEST_DRIVER_VERIFY_VIEW 4
#define TEST_DRIVER_MOVE_TO 5
#define TEST_DRIVER_TILE 6

/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_EVENT_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_PROPERTY_SINCE_VERSION 1

/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_ACTOR_DESTROYED_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_EFFECTS_COMPLETED_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_WINDOW_SHOWN_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_POINT_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_VERIFY_VIEW_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_MOVE_TO_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_TILE_SINCE_VERSION 1

/** @ingroup iface_test_driver */
static inline void
test_driver_set_user_data(struct test_driver *test_driver, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) test_driver, user_data);
}

/** @ingroup iface_test_driver */
static inline void *
test_driver_get_user_data(struct test_driver *test_driver)
{
	return wl_proxy_get_user_data((struct wl_proxy *) test_driver);
}

static inline uint32_t
test_driver_get_version(struct test_driver *test_driver)
{
	return wl_proxy_get_version((struct wl_proxy *) test_driver);
}

/** @ingroup iface_test_driver */
static inline void
test_driver_destroy(struct test_driver *test_driver)
{
	wl_proxy_destroy((struct wl_proxy *) test_driver);
}

/**
 * @ingroup iface_test_driver
 */
static inline struct wl_callback *
test_driver_sync_actor_destroyed(struct test_driver *test_driver, struct wl_surface *surface)
{
	struct wl_proxy *callback;

	callback = wl_proxy_marshal_flags((struct wl_proxy *) test_driver,
			 TEST_DRIVER_SYNC_ACTOR_DESTROYED, &wl_callback_interface, wl_proxy_get_version((struct wl_proxy *) test_driver), 0, NULL, surface);

	return (struct wl_callback *) callback;
}

/**
 * @ingroup iface_test_driver
 */
static inline struct wl_callback *
test_driver_sync_effects_completed(struct test_driver *test_driver, struct wl_surface *surface)
{
	struct wl_proxy *callback;

	callback = wl_proxy_marshal_flags((struct wl_proxy *) test_driver,
			 TEST_DRIVER_SYNC_EFFECTS_COMPLETED, &wl_callback_interface, wl_proxy_get_version((struct wl_proxy *) test_driver), 0, NULL, surface);

	return (struct wl_callback *) callback;
}

/**
 * @ingroup iface_test_driver
 */
static inline struct wl_callback *
test_driver_sync_window_shown(struct test_driver *test_driver, struct wl_surface *surface)
{
	struct wl_proxy *callback;

	callback = wl_proxy_marshal_flags((struct wl_proxy *) test_driver,
			 TEST_DRIVER_SYNC_WINDOW_SHOWN, &wl_callback_interface, wl_proxy_get_version((struct wl_proxy *) test_driver), 0, NULL, surface);

	return (struct wl_callback *) callback;
}

/**
 * @ingroup iface_test_driver
 */
static inline void
test_driver_sync_point(struct test_driver *test_driver, uint32_t sequence, struct wl_surface *surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) test_driver,
			 TEST_DRIVER_SYNC_POINT, NULL, wl_proxy_get_version((struct wl_proxy *) test_driver), 0, sequence, surface);
}

/**
 * @ingroup iface_test_driver
 */
static inline struct wl_callback *
test_driver_verify_view(struct test_driver *test_driver, uint32_t sequence)
{
	struct wl_proxy *callback;

	callback = wl_proxy_marshal_flags((struct wl_proxy *) test_driver,
			 TEST_DRIVER_VERIFY_VIEW, &wl_callback_interface, wl_proxy_get_version((struct wl_proxy *) test_driver), 0, NULL, sequence);

	return (struct wl_callback *) callback;
}

/**
 * @ingroup iface_test_driver
 */
static inline void
test_driver_move_to(struct test_driver *test_driver, struct wl_surface *surface, int32_t x, int32_t y)
{
	wl_proxy_marshal_flags((struct wl_proxy *) test_driver,
			 TEST_DRIVER_MOVE_TO, NULL, wl_proxy_get_version((struct wl_proxy *) test_driver), 0, surface, x, y);
}

/**
 * @ingroup iface_test_driver
 */
static inline void
test_driver_tile(struct test_driver *test_driver, struct wl_surface *surface, uint32_t direction)
{
	wl_proxy_marshal_flags((struct wl_proxy *) test_driver,
			 TEST_DRIVER_TILE, NULL, wl_proxy_get_version((struct wl_proxy *) test_driver), 0, surface, direction);
}

#ifdef  __cplusplus
}
#endif

#endif
